unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1Paint(Sender: TObject);
  private
    Pic: TPicture;
    FShowPic: Boolean;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Picture.LoadFromFile('PNG_transparency_demonstration_1.png');
  Image1.Stretch:=True;
  Pic:=TPicture.Create;
  Pic.LoadFromFile('PNG_transparency_demonstration_1.png');
  Doublebuffered:=True;
  FShowPic:=False;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Pic.Free;
end;

procedure TForm1.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then FShowPic:=True;
end;

procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if FShowPic then Repaint;
end;

procedure TForm1.Image1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FShowPic:=False;
  Repaint;
end;

procedure TForm1.Image1Paint(Sender: TObject);
var
  MouseP: TPoint;
  aRect: TRect;
begin
  if FShowPic then begin
    MouseP:=Mouse.CursorPos;
    MouseP:=Image1.ScreenToClient(MouseP);
    aRect.Left   := MouseP.x - ClientWidth div 4;
    aRect.Top    := MouseP.y - ClientHeight div 4;
    aRect.Right  := MouseP.x + ClientWidth div 4;
    aRect.Bottom := MouseP.y + ClientHeight div 4;
    Image1.Canvas.StretchDraw(aRect, Pic.Bitmap);
  end;
end;

end.

